import { AbstractRepository } from '@crosslab/service-common';
import { DeviceGroupModel } from '../../model.js';
export class DeviceGroupRepository extends AbstractRepository {
    dependencies = {};
    constructor() {
        super('Device Group');
    }
    dependenciesMet() {
        if (!this.dependencies.deviceOverview)
            return false;
        return true;
    }
    initialize(entityManager) {
        this.repository = entityManager.getRepository(DeviceGroupModel);
    }
    async create(data) {
        const model = await super.create(data);
        model.type = 'group';
        return model;
    }
    async write(model, data) {
        if (!this.isInitialized())
            this.throwUninitializedRepositoryError();
        await this.dependencies.deviceOverview.write(model, data);
        if (data.devices)
            model.devices = data.devices;
    }
    async format(model) {
        if (!this.isInitialized())
            this.throwUninitializedRepositoryError();
        const devices = model.devices;
        return {
            ...(await this.dependencies.deviceOverview.format(model)),
            type: 'group',
            devices: devices.filter((value, index, array) => array.findIndex(device => device.url === value.url) === index),
        };
    }
}
//# sourceMappingURL=deviceGroup.js.map